/* * test_motors.cpp * * Created: 11/23/2013 3:19:02 AM * Author: student */
#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#define c 261
#define d 294
#define e 329
#define f 349
#define g 391
#define gS 415
#define a 440
#define aS 455
#define b 466
#define cH 523
#define cSH 554
#define dH 587
#define dSH 622
#define eH 659
#define fH 698
#define fSH 740
#define gH 784
#define gSH 830
#define aH 880

uint16_t surprise_notes [9] = {  a, a, a, f, cH, a, f, cH, a};


void init_timer() {
	//buzzer
	//PD5 output - OC1A este PD5
	DDRD |= (1 << PD5) | (1 << PD4);
	TCCR1A |= (1 << WGM10);
	TCCR1B |= (1 << WGM12);
	TCCR1A |= (1 << COM1A1);
	TCCR1B |= (1 << CS12) | (1 << CS10);
	OCR1A = 65535 / 2;
}

int main(void)
{
	unsigned int value[8];
	//timer 0
	//output pb3 pb4
	
	// initializare timer
	init_timer();
	
	// initializare Timer 0 pentru intrerupere la 8ms
	DDRB |= (1 << PB3) | (1 << PB4);
	// PD6 is now an output
	OCR0A = 150;
	// set PWM for 50% duty cycle
	TCCR0A |= (1 << COM0A1);
	// set none-inverting mode
	TCCR0A |= (1 << WGM01) | (1 << WGM00);
	// set fast PWM Mode
	TCCR0B |= (1 << CS01);
	// set prescaler to 8 and starts PWM
	//timer 2
	DDRD |= (1 << PD6) | (1 << PD7);
	OCR2A = 150;
	// set PWM for 50% duty cycle
	TCCR2A |= (1 << COM2A1);
	// set none-inverting mode
	TCCR2A |= (1 << WGM21) | (1 << WGM20);
	// set fast PWM Mode
	TCCR2B |= (1 << CS21);
	
	int i = 0,j = 0,k = 0;
	while(1)
	{
		OCR1A = surprise_notes[i++ % 9];
		if((j % 4) == 1)
		{
			for(k = 0; k < 999; ++ k)
			{
				OCR2A = 0;
				OCR0A = 150;
				OCR2B = 0;
				OCR0B = 0;
			}
			++ j;
		}
		else if((j % 4) == 2)
		{
			for(k = 0; k < 999; ++ k)
			{
				OCR2A = 0;
				OCR0A = 150;
				OCR2B = 0;
				OCR0B = 0;
			}
			++ j;
		}
		else if((j % 4) == 3)
		{
			for(k = 0; k < 999; ++ k)
			{
				OCR2B = 150;
				OCR2A = 0;
				OCR0B = 150;
				OCR0A = 0;
			}
			++ j;
		}
		else
		{
			for(k = 0; k < 999; ++ k)
			{
				OCR0A = 150;
				OCR2A = 150;
				OCR0B = 0;
				OCR2B = 0;
			}
			++ j;
		}
		
	}
}
